// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetClustersObservableReader is a Reader for the GetClustersObservable structure.
type GetClustersObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetClustersObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetClustersObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetClustersObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetClustersObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetClustersObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetClustersObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetClustersObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetClustersObservableOK creates a GetClustersObservableOK with default headers values
func NewGetClustersObservableOK() *GetClustersObservableOK {
	return &GetClustersObservableOK{}
}

/*
GetClustersObservableOK describes a response with status code 200, with default header values.

Single Cluster record response
*/
type GetClustersObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.Cluster
}

// IsSuccess returns true when this get clusters observable o k response has a 2xx status code
func (o *GetClustersObservableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get clusters observable o k response has a 3xx status code
func (o *GetClustersObservableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters observable o k response has a 4xx status code
func (o *GetClustersObservableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get clusters observable o k response has a 5xx status code
func (o *GetClustersObservableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters observable o k response a status code equal to that given
func (o *GetClustersObservableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get clusters observable o k response
func (o *GetClustersObservableOK) Code() int {
	return 200
}

func (o *GetClustersObservableOK) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableOK  %+v", 200, o.Payload)
}

func (o *GetClustersObservableOK) String() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableOK  %+v", 200, o.Payload)
}

func (o *GetClustersObservableOK) GetPayload() []*devops_models.Cluster {
	return o.Payload
}

func (o *GetClustersObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableUnauthorized creates a GetClustersObservableUnauthorized with default headers values
func NewGetClustersObservableUnauthorized() *GetClustersObservableUnauthorized {
	return &GetClustersObservableUnauthorized{}
}

/*
GetClustersObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetClustersObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get clusters observable unauthorized response has a 2xx status code
func (o *GetClustersObservableUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters observable unauthorized response has a 3xx status code
func (o *GetClustersObservableUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters observable unauthorized response has a 4xx status code
func (o *GetClustersObservableUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters observable unauthorized response has a 5xx status code
func (o *GetClustersObservableUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters observable unauthorized response a status code equal to that given
func (o *GetClustersObservableUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get clusters observable unauthorized response
func (o *GetClustersObservableUnauthorized) Code() int {
	return 401
}

func (o *GetClustersObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetClustersObservableUnauthorized) String() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetClustersObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableForbidden creates a GetClustersObservableForbidden with default headers values
func NewGetClustersObservableForbidden() *GetClustersObservableForbidden {
	return &GetClustersObservableForbidden{}
}

/*
GetClustersObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetClustersObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get clusters observable forbidden response has a 2xx status code
func (o *GetClustersObservableForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters observable forbidden response has a 3xx status code
func (o *GetClustersObservableForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters observable forbidden response has a 4xx status code
func (o *GetClustersObservableForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters observable forbidden response has a 5xx status code
func (o *GetClustersObservableForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters observable forbidden response a status code equal to that given
func (o *GetClustersObservableForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get clusters observable forbidden response
func (o *GetClustersObservableForbidden) Code() int {
	return 403
}

func (o *GetClustersObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetClustersObservableForbidden) String() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetClustersObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableNotFound creates a GetClustersObservableNotFound with default headers values
func NewGetClustersObservableNotFound() *GetClustersObservableNotFound {
	return &GetClustersObservableNotFound{}
}

/*
GetClustersObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetClustersObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get clusters observable not found response has a 2xx status code
func (o *GetClustersObservableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters observable not found response has a 3xx status code
func (o *GetClustersObservableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters observable not found response has a 4xx status code
func (o *GetClustersObservableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters observable not found response has a 5xx status code
func (o *GetClustersObservableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters observable not found response a status code equal to that given
func (o *GetClustersObservableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get clusters observable not found response
func (o *GetClustersObservableNotFound) Code() int {
	return 404
}

func (o *GetClustersObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetClustersObservableNotFound) String() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetClustersObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableUnprocessableEntity creates a GetClustersObservableUnprocessableEntity with default headers values
func NewGetClustersObservableUnprocessableEntity() *GetClustersObservableUnprocessableEntity {
	return &GetClustersObservableUnprocessableEntity{}
}

/*
GetClustersObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetClustersObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get clusters observable unprocessable entity response has a 2xx status code
func (o *GetClustersObservableUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters observable unprocessable entity response has a 3xx status code
func (o *GetClustersObservableUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters observable unprocessable entity response has a 4xx status code
func (o *GetClustersObservableUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters observable unprocessable entity response has a 5xx status code
func (o *GetClustersObservableUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters observable unprocessable entity response a status code equal to that given
func (o *GetClustersObservableUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get clusters observable unprocessable entity response
func (o *GetClustersObservableUnprocessableEntity) Code() int {
	return 422
}

func (o *GetClustersObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetClustersObservableUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetClustersObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableInternalServerError creates a GetClustersObservableInternalServerError with default headers values
func NewGetClustersObservableInternalServerError() *GetClustersObservableInternalServerError {
	return &GetClustersObservableInternalServerError{}
}

/*
GetClustersObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetClustersObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get clusters observable internal server error response has a 2xx status code
func (o *GetClustersObservableInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters observable internal server error response has a 3xx status code
func (o *GetClustersObservableInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters observable internal server error response has a 4xx status code
func (o *GetClustersObservableInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get clusters observable internal server error response has a 5xx status code
func (o *GetClustersObservableInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get clusters observable internal server error response a status code equal to that given
func (o *GetClustersObservableInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get clusters observable internal server error response
func (o *GetClustersObservableInternalServerError) Code() int {
	return 500
}

func (o *GetClustersObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetClustersObservableInternalServerError) String() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetClustersObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
