// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// PostClustersReader is a Reader for the PostClusters structure.
type PostClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostClustersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostClustersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostClustersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostClustersOK creates a PostClustersOK with default headers values
func NewPostClustersOK() *PostClustersOK {
	return &PostClustersOK{}
}

/*
PostClustersOK describes a response with status code 200, with default header values.

Response with Cluster objects
*/
type PostClustersOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.ClusterResponse
}

// IsSuccess returns true when this post clusters o k response has a 2xx status code
func (o *PostClustersOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post clusters o k response has a 3xx status code
func (o *PostClustersOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post clusters o k response has a 4xx status code
func (o *PostClustersOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post clusters o k response has a 5xx status code
func (o *PostClustersOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post clusters o k response a status code equal to that given
func (o *PostClustersOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post clusters o k response
func (o *PostClustersOK) Code() int {
	return 200
}

func (o *PostClustersOK) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersOK  %+v", 200, o.Payload)
}

func (o *PostClustersOK) String() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersOK  %+v", 200, o.Payload)
}

func (o *PostClustersOK) GetPayload() *devops_models.ClusterResponse {
	return o.Payload
}

func (o *PostClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.ClusterResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersUnauthorized creates a PostClustersUnauthorized with default headers values
func NewPostClustersUnauthorized() *PostClustersUnauthorized {
	return &PostClustersUnauthorized{}
}

/*
PostClustersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostClustersUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post clusters unauthorized response has a 2xx status code
func (o *PostClustersUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post clusters unauthorized response has a 3xx status code
func (o *PostClustersUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post clusters unauthorized response has a 4xx status code
func (o *PostClustersUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post clusters unauthorized response has a 5xx status code
func (o *PostClustersUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post clusters unauthorized response a status code equal to that given
func (o *PostClustersUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post clusters unauthorized response
func (o *PostClustersUnauthorized) Code() int {
	return 401
}

func (o *PostClustersUnauthorized) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostClustersUnauthorized) String() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostClustersUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostClustersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersForbidden creates a PostClustersForbidden with default headers values
func NewPostClustersForbidden() *PostClustersForbidden {
	return &PostClustersForbidden{}
}

/*
PostClustersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostClustersForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post clusters forbidden response has a 2xx status code
func (o *PostClustersForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post clusters forbidden response has a 3xx status code
func (o *PostClustersForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post clusters forbidden response has a 4xx status code
func (o *PostClustersForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post clusters forbidden response has a 5xx status code
func (o *PostClustersForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post clusters forbidden response a status code equal to that given
func (o *PostClustersForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post clusters forbidden response
func (o *PostClustersForbidden) Code() int {
	return 403
}

func (o *PostClustersForbidden) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersForbidden  %+v", 403, o.Payload)
}

func (o *PostClustersForbidden) String() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersForbidden  %+v", 403, o.Payload)
}

func (o *PostClustersForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostClustersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersNotFound creates a PostClustersNotFound with default headers values
func NewPostClustersNotFound() *PostClustersNotFound {
	return &PostClustersNotFound{}
}

/*
PostClustersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostClustersNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post clusters not found response has a 2xx status code
func (o *PostClustersNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post clusters not found response has a 3xx status code
func (o *PostClustersNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post clusters not found response has a 4xx status code
func (o *PostClustersNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post clusters not found response has a 5xx status code
func (o *PostClustersNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post clusters not found response a status code equal to that given
func (o *PostClustersNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post clusters not found response
func (o *PostClustersNotFound) Code() int {
	return 404
}

func (o *PostClustersNotFound) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersNotFound  %+v", 404, o.Payload)
}

func (o *PostClustersNotFound) String() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersNotFound  %+v", 404, o.Payload)
}

func (o *PostClustersNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersUnprocessableEntity creates a PostClustersUnprocessableEntity with default headers values
func NewPostClustersUnprocessableEntity() *PostClustersUnprocessableEntity {
	return &PostClustersUnprocessableEntity{}
}

/*
PostClustersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostClustersUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post clusters unprocessable entity response has a 2xx status code
func (o *PostClustersUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post clusters unprocessable entity response has a 3xx status code
func (o *PostClustersUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post clusters unprocessable entity response has a 4xx status code
func (o *PostClustersUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post clusters unprocessable entity response has a 5xx status code
func (o *PostClustersUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post clusters unprocessable entity response a status code equal to that given
func (o *PostClustersUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post clusters unprocessable entity response
func (o *PostClustersUnprocessableEntity) Code() int {
	return 422
}

func (o *PostClustersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostClustersUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostClustersUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostClustersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersInternalServerError creates a PostClustersInternalServerError with default headers values
func NewPostClustersInternalServerError() *PostClustersInternalServerError {
	return &PostClustersInternalServerError{}
}

/*
PostClustersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostClustersInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post clusters internal server error response has a 2xx status code
func (o *PostClustersInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post clusters internal server error response has a 3xx status code
func (o *PostClustersInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post clusters internal server error response has a 4xx status code
func (o *PostClustersInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post clusters internal server error response has a 5xx status code
func (o *PostClustersInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post clusters internal server error response a status code equal to that given
func (o *PostClustersInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post clusters internal server error response
func (o *PostClustersInternalServerError) Code() int {
	return 500
}

func (o *PostClustersInternalServerError) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostClustersInternalServerError) String() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostClustersInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
