// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package database

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetDatabaseReader is a Reader for the GetDatabase structure.
type GetDatabaseReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDatabaseReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDatabaseOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetDatabaseUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetDatabaseForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetDatabaseNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetDatabaseUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetDatabaseInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetDatabaseOK creates a GetDatabaseOK with default headers values
func NewGetDatabaseOK() *GetDatabaseOK {
	return &GetDatabaseOK{}
}

/*
GetDatabaseOK describes a response with status code 200, with default header values.

Single Database record response
*/
type GetDatabaseOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Database
}

// IsSuccess returns true when this get database o k response has a 2xx status code
func (o *GetDatabaseOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get database o k response has a 3xx status code
func (o *GetDatabaseOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get database o k response has a 4xx status code
func (o *GetDatabaseOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get database o k response has a 5xx status code
func (o *GetDatabaseOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get database o k response a status code equal to that given
func (o *GetDatabaseOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get database o k response
func (o *GetDatabaseOK) Code() int {
	return 200
}

func (o *GetDatabaseOK) Error() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseOK  %+v", 200, o.Payload)
}

func (o *GetDatabaseOK) String() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseOK  %+v", 200, o.Payload)
}

func (o *GetDatabaseOK) GetPayload() *devops_models.Database {
	return o.Payload
}

func (o *GetDatabaseOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Database)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabaseUnauthorized creates a GetDatabaseUnauthorized with default headers values
func NewGetDatabaseUnauthorized() *GetDatabaseUnauthorized {
	return &GetDatabaseUnauthorized{}
}

/*
GetDatabaseUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetDatabaseUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get database unauthorized response has a 2xx status code
func (o *GetDatabaseUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get database unauthorized response has a 3xx status code
func (o *GetDatabaseUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get database unauthorized response has a 4xx status code
func (o *GetDatabaseUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get database unauthorized response has a 5xx status code
func (o *GetDatabaseUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get database unauthorized response a status code equal to that given
func (o *GetDatabaseUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get database unauthorized response
func (o *GetDatabaseUnauthorized) Code() int {
	return 401
}

func (o *GetDatabaseUnauthorized) Error() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabaseUnauthorized) String() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabaseUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabaseUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabaseForbidden creates a GetDatabaseForbidden with default headers values
func NewGetDatabaseForbidden() *GetDatabaseForbidden {
	return &GetDatabaseForbidden{}
}

/*
GetDatabaseForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetDatabaseForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get database forbidden response has a 2xx status code
func (o *GetDatabaseForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get database forbidden response has a 3xx status code
func (o *GetDatabaseForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get database forbidden response has a 4xx status code
func (o *GetDatabaseForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get database forbidden response has a 5xx status code
func (o *GetDatabaseForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get database forbidden response a status code equal to that given
func (o *GetDatabaseForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get database forbidden response
func (o *GetDatabaseForbidden) Code() int {
	return 403
}

func (o *GetDatabaseForbidden) Error() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabaseForbidden) String() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabaseForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabaseForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabaseNotFound creates a GetDatabaseNotFound with default headers values
func NewGetDatabaseNotFound() *GetDatabaseNotFound {
	return &GetDatabaseNotFound{}
}

/*
GetDatabaseNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetDatabaseNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get database not found response has a 2xx status code
func (o *GetDatabaseNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get database not found response has a 3xx status code
func (o *GetDatabaseNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get database not found response has a 4xx status code
func (o *GetDatabaseNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get database not found response has a 5xx status code
func (o *GetDatabaseNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get database not found response a status code equal to that given
func (o *GetDatabaseNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get database not found response
func (o *GetDatabaseNotFound) Code() int {
	return 404
}

func (o *GetDatabaseNotFound) Error() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabaseNotFound) String() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabaseNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabaseNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabaseUnprocessableEntity creates a GetDatabaseUnprocessableEntity with default headers values
func NewGetDatabaseUnprocessableEntity() *GetDatabaseUnprocessableEntity {
	return &GetDatabaseUnprocessableEntity{}
}

/*
GetDatabaseUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetDatabaseUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get database unprocessable entity response has a 2xx status code
func (o *GetDatabaseUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get database unprocessable entity response has a 3xx status code
func (o *GetDatabaseUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get database unprocessable entity response has a 4xx status code
func (o *GetDatabaseUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get database unprocessable entity response has a 5xx status code
func (o *GetDatabaseUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get database unprocessable entity response a status code equal to that given
func (o *GetDatabaseUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get database unprocessable entity response
func (o *GetDatabaseUnprocessableEntity) Code() int {
	return 422
}

func (o *GetDatabaseUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabaseUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabaseUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabaseUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabaseInternalServerError creates a GetDatabaseInternalServerError with default headers values
func NewGetDatabaseInternalServerError() *GetDatabaseInternalServerError {
	return &GetDatabaseInternalServerError{}
}

/*
GetDatabaseInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetDatabaseInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get database internal server error response has a 2xx status code
func (o *GetDatabaseInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get database internal server error response has a 3xx status code
func (o *GetDatabaseInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get database internal server error response has a 4xx status code
func (o *GetDatabaseInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get database internal server error response has a 5xx status code
func (o *GetDatabaseInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get database internal server error response a status code equal to that given
func (o *GetDatabaseInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get database internal server error response
func (o *GetDatabaseInternalServerError) Code() int {
	return 500
}

func (o *GetDatabaseInternalServerError) Error() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabaseInternalServerError) String() string {
	return fmt.Sprintf("[GET /databases/{databaseIdPath}][%d] getDatabaseInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabaseInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabaseInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
