// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteContactsParams creates a new DeleteContactsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteContactsParams() *DeleteContactsParams {
	return &DeleteContactsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteContactsParamsWithTimeout creates a new DeleteContactsParams object
// with the ability to set a timeout on a request.
func NewDeleteContactsParamsWithTimeout(timeout time.Duration) *DeleteContactsParams {
	return &DeleteContactsParams{
		timeout: timeout,
	}
}

// NewDeleteContactsParamsWithContext creates a new DeleteContactsParams object
// with the ability to set a context for a request.
func NewDeleteContactsParamsWithContext(ctx context.Context) *DeleteContactsParams {
	return &DeleteContactsParams{
		Context: ctx,
	}
}

// NewDeleteContactsParamsWithHTTPClient creates a new DeleteContactsParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteContactsParamsWithHTTPClient(client *http.Client) *DeleteContactsParams {
	return &DeleteContactsParams{
		HTTPClient: client,
	}
}

/*
DeleteContactsParams contains all the parameters to send to the API endpoint

	for the delete contacts operation.

	Typically these are written to a http.Request.
*/
type DeleteContactsParams struct {

	/* ContactID.

	   Record Id of a Contact
	*/
	ContactID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete contacts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteContactsParams) WithDefaults() *DeleteContactsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete contacts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteContactsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete contacts params
func (o *DeleteContactsParams) WithTimeout(timeout time.Duration) *DeleteContactsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete contacts params
func (o *DeleteContactsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete contacts params
func (o *DeleteContactsParams) WithContext(ctx context.Context) *DeleteContactsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete contacts params
func (o *DeleteContactsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete contacts params
func (o *DeleteContactsParams) WithHTTPClient(client *http.Client) *DeleteContactsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete contacts params
func (o *DeleteContactsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContactID adds the contactID to the delete contacts params
func (o *DeleteContactsParams) WithContactID(contactID *string) *DeleteContactsParams {
	o.SetContactID(contactID)
	return o
}

// SetContactID adds the contactId to the delete contacts params
func (o *DeleteContactsParams) SetContactID(contactID *string) {
	o.ContactID = contactID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteContactsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ContactID != nil {

		// query param contactId
		var qrContactID string

		if o.ContactID != nil {
			qrContactID = *o.ContactID
		}
		qContactID := qrContactID
		if qContactID != "" {

			if err := r.SetQueryParam("contactId", qContactID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
