// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// PostContactsReader is a Reader for the PostContacts structure.
type PostContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewPostContactsCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostContactsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostContactsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostContactsCreated creates a PostContactsCreated with default headers values
func NewPostContactsCreated() *PostContactsCreated {
	return &PostContactsCreated{}
}

/*
PostContactsCreated describes a response with status code 201, with default header values.

Response from Salesforce
*/
type PostContactsCreated struct {
	Payload *sfgate_models.SalesforcePostResponse
}

// IsSuccess returns true when this post contacts created response has a 2xx status code
func (o *PostContactsCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post contacts created response has a 3xx status code
func (o *PostContactsCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contacts created response has a 4xx status code
func (o *PostContactsCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this post contacts created response has a 5xx status code
func (o *PostContactsCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this post contacts created response a status code equal to that given
func (o *PostContactsCreated) IsCode(code int) bool {
	return code == 201
}

// Code gets the status code for the post contacts created response
func (o *PostContactsCreated) Code() int {
	return 201
}

func (o *PostContactsCreated) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsCreated  %+v", 201, o.Payload)
}

func (o *PostContactsCreated) String() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsCreated  %+v", 201, o.Payload)
}

func (o *PostContactsCreated) GetPayload() *sfgate_models.SalesforcePostResponse {
	return o.Payload
}

func (o *PostContactsCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.SalesforcePostResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsUnauthorized creates a PostContactsUnauthorized with default headers values
func NewPostContactsUnauthorized() *PostContactsUnauthorized {
	return &PostContactsUnauthorized{}
}

/*
PostContactsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostContactsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post contacts unauthorized response has a 2xx status code
func (o *PostContactsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contacts unauthorized response has a 3xx status code
func (o *PostContactsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contacts unauthorized response has a 4xx status code
func (o *PostContactsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post contacts unauthorized response has a 5xx status code
func (o *PostContactsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post contacts unauthorized response a status code equal to that given
func (o *PostContactsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post contacts unauthorized response
func (o *PostContactsUnauthorized) Code() int {
	return 401
}

func (o *PostContactsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostContactsUnauthorized) String() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostContactsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostContactsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsForbidden creates a PostContactsForbidden with default headers values
func NewPostContactsForbidden() *PostContactsForbidden {
	return &PostContactsForbidden{}
}

/*
PostContactsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostContactsForbidden struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post contacts forbidden response has a 2xx status code
func (o *PostContactsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contacts forbidden response has a 3xx status code
func (o *PostContactsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contacts forbidden response has a 4xx status code
func (o *PostContactsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post contacts forbidden response has a 5xx status code
func (o *PostContactsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post contacts forbidden response a status code equal to that given
func (o *PostContactsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post contacts forbidden response
func (o *PostContactsForbidden) Code() int {
	return 403
}

func (o *PostContactsForbidden) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsForbidden  %+v", 403, o.Payload)
}

func (o *PostContactsForbidden) String() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsForbidden  %+v", 403, o.Payload)
}

func (o *PostContactsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsNotFound creates a PostContactsNotFound with default headers values
func NewPostContactsNotFound() *PostContactsNotFound {
	return &PostContactsNotFound{}
}

/*
PostContactsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostContactsNotFound struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post contacts not found response has a 2xx status code
func (o *PostContactsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contacts not found response has a 3xx status code
func (o *PostContactsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contacts not found response has a 4xx status code
func (o *PostContactsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post contacts not found response has a 5xx status code
func (o *PostContactsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post contacts not found response a status code equal to that given
func (o *PostContactsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post contacts not found response
func (o *PostContactsNotFound) Code() int {
	return 404
}

func (o *PostContactsNotFound) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsNotFound  %+v", 404, o.Payload)
}

func (o *PostContactsNotFound) String() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsNotFound  %+v", 404, o.Payload)
}

func (o *PostContactsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostContactsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsInternalServerError creates a PostContactsInternalServerError with default headers values
func NewPostContactsInternalServerError() *PostContactsInternalServerError {
	return &PostContactsInternalServerError{}
}

/*
PostContactsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostContactsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post contacts internal server error response has a 2xx status code
func (o *PostContactsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contacts internal server error response has a 3xx status code
func (o *PostContactsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contacts internal server error response has a 4xx status code
func (o *PostContactsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post contacts internal server error response has a 5xx status code
func (o *PostContactsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post contacts internal server error response a status code equal to that given
func (o *PostContactsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post contacts internal server error response
func (o *PostContactsInternalServerError) Code() int {
	return 500
}

func (o *PostContactsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostContactsInternalServerError) String() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostContactsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
